class Outpace
  def self.ensure_aws_credentials
    raise <<-AWS unless ENV.keys.include?("AWS_ACCESS_KEY_ID") && ENV.keys.include?("AWS_SECRET_ACCESS_KEY")
    You don't seem to have AWS_ACCESS_KEY_ID & AWS_SECRET_ACCESS_KEY
    AWS

    require 'time'
    raise <<-AWS if ENV["AWS_SECURITY_TOKEN_TIMESTAMP"] && Time.parse(ENV["AWS_SECURITY_TOKEN_TIMESTAMP"]) - Time.now < 0
    You need to run derp authenticate again, your authentication seems to have expired
    AWS
  end

  def self.clojure_profile
    case ENV['ENVIRONMENT_NAME']
      when 'prod' then 'production'
      when /^qa/ then 'qa'
      when /dev/, nil then 'dev'
      else raise "Unrecognized $ENVIRONMENT_NAME: #{ENV['ENVIRONMENT_NAME'].inspect}"
    end
  end

  def self.run_jar_with_new_relic(service, jar_file)
    ENV["NEW_RELIC_LOG"] = "#{service}.log"
    jvm_opts = []

    case clojure_profile
    when 'production' 
      ENV["NEW_RELIC_APP_NAME"] = service
      jvm_opts << "-Dnewrelic.environment=production"
      jvm_opts << "-javaagent:../clojure/newrelic/newrelic.jar"
    when 'qa' then "_qa"
      ENV["NEW_RELIC_APP_NAME"] = "#{service}_qa"
      jvm_opts << "-Dnewrelic.environment=qa"
    when 'dev'
      ENV["NEW_RELIC_APP_NAME"] = "#{service}_dev"
      jvm_opts << "-Dnewrelic.environment=development"
    end

    puts "Starting #{service}"
    cmd = (["java"] + jvm_opts + ["-jar", jar_file]).join(" ")
    puts "Executing #{cmd}"
    exec cmd
  end
end